<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 7/9/17
 * Time: 3:14 PM
 */

namespace qfq;

use qfq;

require_once(__DIR__ . '/../../qfq/helper/Sanitize.php');

/**
 * Class Client
 * @package qfq
 */
class Client {

    /**
     * @return array|string
     * @throws CodeException
     */
    public static function getParam() {

        // copy GET and POST and SERVER Parameter. Priority: SERVER, POST, GET
        $get = array();
        $post = array();
        $cookie = array();
        $server = array();

        // Dirty workaround to clean poisoned T3 cache
        Sanitize::digitCheckAndCleanGet(CLIENT_PAGE_TYPE);
        Sanitize::digitCheckAndCleanGet(CLIENT_PAGE_LANGUAGE);

        if (isset($_GET)) {
            $get = $_GET; // do not use urldecode() - http://php.net/manual/de/function.urldecode.php#refsect1-function.urldecode-notes
        }

        if (isset($_POST)) {
            $post = $_POST;
//            Logger::logMessage(var_export($post, true) . PHP_EOL . PHP_EOL,'post.txt');
        }

        if (isset($_COOKIE[SESSION_NAME])) {
            $cookie[CLIENT_COOKIE_QFQ] = $_COOKIE[SESSION_NAME];
        }

        // It's important to merge the SERVER array last: those entries shall overwrite client values.
        if (isset($_SERVER)) {
            $server = Sanitize::htmlentitiesArr($_SERVER); // $_SERVER values might be compromised.
        }

        // Necessary for phpUnit Tests
        if (!isset($server[CLIENT_REMOTE_ADDRESS])) {
            $server[CLIENT_REMOTE_ADDRESS] = '0.0.0.0';
        }

        $arr = array_merge($get, $post, $cookie, $server);

        return Sanitize::normalize($arr);
    }
}